/*
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.apileague;

import com.apileague.client.ApiCallback;
import com.apileague.client.ApiClient;
import com.apileague.client.ApiException;
import com.apileague.client.ApiResponse;
import com.apileague.client.Configuration;
import com.apileague.client.Pair;
import com.apileague.client.ProgressRequestBody;
import com.apileague.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.apileague.client.model.ComputeNutritionAPI200Response;
import com.apileague.client.model.RetrieveRecipeInformationAPI200Response;
import com.apileague.client.model.SearchDrinksAPI200Response;
import com.apileague.client.model.SearchRecipesAPI200Response;
import com.apileague.client.model.SearchRestaurantsAPI200Response;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class FoodApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public FoodApi() {
        this(Configuration.getDefaultApiClient());
    }

    public FoodApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for computeNutritionAPI
     * @param ingredients A comma-separated list of the ingredients of the recipe. (required)
     * @param servings The number of servings the ingredients make. Nutrition is computed per serving. (optional)
     * @param reduceOils If there is oil in the ingredients, e.g. 3 tablespoons olive oil but they are used for frying, not all of the oil is consumed and therefore should not be added to the computed nutrition. In this case set reduce-oils to true. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/compute-nutrition-api/">Compute Nutrition API Documentation</a>
     */
    public okhttp3.Call computeNutritionAPICall(String ingredients, Integer servings, Boolean reduceOils, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/compute-nutrition";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (ingredients != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("ingredients", ingredients));
        }

        if (servings != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("servings", servings));
        }

        if (reduceOils != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("reduce-oils", reduceOils));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "apiKey", "headerApiKey" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call computeNutritionAPIValidateBeforeCall(String ingredients, Integer servings, Boolean reduceOils, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'ingredients' is set
        if (ingredients == null) {
            throw new ApiException("Missing the required parameter 'ingredients' when calling computeNutritionAPI(Async)");
        }

        return computeNutritionAPICall(ingredients, servings, reduceOils, _callback);

    }

    /**
     * Compute Nutrition API
     * Compute detailed nutritional information for a given recipe (list of ingredients). The API will return the nutritional information for each ingredient, as well as the total nutritional content for the entire recipe. Aside from macro and micro nutrients, the API also returns flavanoid information and food properties such as glycemic index, glycemic load, and inflammation score.
     * @param ingredients A comma-separated list of the ingredients of the recipe. (required)
     * @param servings The number of servings the ingredients make. Nutrition is computed per serving. (optional)
     * @param reduceOils If there is oil in the ingredients, e.g. 3 tablespoons olive oil but they are used for frying, not all of the oil is consumed and therefore should not be added to the computed nutrition. In this case set reduce-oils to true. (optional)
     * @return ComputeNutritionAPI200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/compute-nutrition-api/">Compute Nutrition API Documentation</a>
     */
    public ComputeNutritionAPI200Response computeNutritionAPI(String ingredients, Integer servings, Boolean reduceOils) throws ApiException {
        ApiResponse<ComputeNutritionAPI200Response> localVarResp = computeNutritionAPIWithHttpInfo(ingredients, servings, reduceOils);
        return localVarResp.getData();
    }

    /**
     * Compute Nutrition API
     * Compute detailed nutritional information for a given recipe (list of ingredients). The API will return the nutritional information for each ingredient, as well as the total nutritional content for the entire recipe. Aside from macro and micro nutrients, the API also returns flavanoid information and food properties such as glycemic index, glycemic load, and inflammation score.
     * @param ingredients A comma-separated list of the ingredients of the recipe. (required)
     * @param servings The number of servings the ingredients make. Nutrition is computed per serving. (optional)
     * @param reduceOils If there is oil in the ingredients, e.g. 3 tablespoons olive oil but they are used for frying, not all of the oil is consumed and therefore should not be added to the computed nutrition. In this case set reduce-oils to true. (optional)
     * @return ApiResponse&lt;ComputeNutritionAPI200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/compute-nutrition-api/">Compute Nutrition API Documentation</a>
     */
    public ApiResponse<ComputeNutritionAPI200Response> computeNutritionAPIWithHttpInfo(String ingredients, Integer servings, Boolean reduceOils) throws ApiException {
        okhttp3.Call localVarCall = computeNutritionAPIValidateBeforeCall(ingredients, servings, reduceOils, null);
        Type localVarReturnType = new TypeToken<ComputeNutritionAPI200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Compute Nutrition API (asynchronously)
     * Compute detailed nutritional information for a given recipe (list of ingredients). The API will return the nutritional information for each ingredient, as well as the total nutritional content for the entire recipe. Aside from macro and micro nutrients, the API also returns flavanoid information and food properties such as glycemic index, glycemic load, and inflammation score.
     * @param ingredients A comma-separated list of the ingredients of the recipe. (required)
     * @param servings The number of servings the ingredients make. Nutrition is computed per serving. (optional)
     * @param reduceOils If there is oil in the ingredients, e.g. 3 tablespoons olive oil but they are used for frying, not all of the oil is consumed and therefore should not be added to the computed nutrition. In this case set reduce-oils to true. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/compute-nutrition-api/">Compute Nutrition API Documentation</a>
     */
    public okhttp3.Call computeNutritionAPIAsync(String ingredients, Integer servings, Boolean reduceOils, final ApiCallback<ComputeNutritionAPI200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = computeNutritionAPIValidateBeforeCall(ingredients, servings, reduceOils, _callback);
        Type localVarReturnType = new TypeToken<ComputeNutritionAPI200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for retrieveRecipeInformationAPI
     * @param id The id of the recipe to retrieve. (required)
     * @param addWinePairing Whether to pair a wine to the recipe. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/retrieve-recipe-api/">Retrieve Recipe Information API Documentation</a>
     */
    public okhttp3.Call retrieveRecipeInformationAPICall(Integer id, Boolean addWinePairing, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/retrieve-recipe";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (id != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("id", id));
        }

        if (addWinePairing != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("add-wine-pairing", addWinePairing));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "apiKey", "headerApiKey" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call retrieveRecipeInformationAPIValidateBeforeCall(Integer id, Boolean addWinePairing, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling retrieveRecipeInformationAPI(Async)");
        }

        return retrieveRecipeInformationAPICall(id, addWinePairing, _callback);

    }

    /**
     * Retrieve Recipe Information API
     * Get detailed recipe information such as dietary properties, macro and micro nutrients, used ingredients and their amounts, and more.
     * @param id The id of the recipe to retrieve. (required)
     * @param addWinePairing Whether to pair a wine to the recipe. (optional)
     * @return RetrieveRecipeInformationAPI200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/retrieve-recipe-api/">Retrieve Recipe Information API Documentation</a>
     */
    public RetrieveRecipeInformationAPI200Response retrieveRecipeInformationAPI(Integer id, Boolean addWinePairing) throws ApiException {
        ApiResponse<RetrieveRecipeInformationAPI200Response> localVarResp = retrieveRecipeInformationAPIWithHttpInfo(id, addWinePairing);
        return localVarResp.getData();
    }

    /**
     * Retrieve Recipe Information API
     * Get detailed recipe information such as dietary properties, macro and micro nutrients, used ingredients and their amounts, and more.
     * @param id The id of the recipe to retrieve. (required)
     * @param addWinePairing Whether to pair a wine to the recipe. (optional)
     * @return ApiResponse&lt;RetrieveRecipeInformationAPI200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/retrieve-recipe-api/">Retrieve Recipe Information API Documentation</a>
     */
    public ApiResponse<RetrieveRecipeInformationAPI200Response> retrieveRecipeInformationAPIWithHttpInfo(Integer id, Boolean addWinePairing) throws ApiException {
        okhttp3.Call localVarCall = retrieveRecipeInformationAPIValidateBeforeCall(id, addWinePairing, null);
        Type localVarReturnType = new TypeToken<RetrieveRecipeInformationAPI200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieve Recipe Information API (asynchronously)
     * Get detailed recipe information such as dietary properties, macro and micro nutrients, used ingredients and their amounts, and more.
     * @param id The id of the recipe to retrieve. (required)
     * @param addWinePairing Whether to pair a wine to the recipe. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/retrieve-recipe-api/">Retrieve Recipe Information API Documentation</a>
     */
    public okhttp3.Call retrieveRecipeInformationAPIAsync(Integer id, Boolean addWinePairing, final ApiCallback<RetrieveRecipeInformationAPI200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = retrieveRecipeInformationAPIValidateBeforeCall(id, addWinePairing, _callback);
        Type localVarReturnType = new TypeToken<RetrieveRecipeInformationAPI200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for searchDrinksAPI
     * @param query The search query. (optional)
     * @param glassTypes A comma-separated list (interpreted as OR) of glass types that the drink should be served in. (optional)
     * @param flavors A comma-separated list (interpreted as AND) of dominant flavors in the drink. (optional)
     * @param diet The diet the drink must adhere to. One of the following: paleo,primal,grain-free,vegan,vegetarian. (optional)
     * @param includeIngredients A comma-separated list of ingredients that should/must be used in the drinks. (optional)
     * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the drinks must not contain. (optional)
     * @param minCalories The minimum amount of calories the drink must have per serving. (optional)
     * @param maxCalories The maximum amount of calories the drink can have per serving. (optional)
     * @param minCarbs The minimum amount of carbohydrates in grams the drink must have per serving. (optional)
     * @param maxCarbs The maximum amount of carbohydrates in grams the drink can have per serving. (optional)
     * @param minProtein The minimum amount of protein in grams the drink must have per serving. (optional)
     * @param maxProtein The maximum amount of protein in grams the drink can have per serving. (optional)
     * @param minFat The minimum amount of fat in grams the drink must have per serving. (optional)
     * @param maxFat The maximum amount of fat in grams the drink can have per serving. (optional)
     * @param minAlcoholPercent The minimum alcohol percentage the drink must have. (optional)
     * @param maxAlcoholPercent The maximum alcohol percentage the drink can have. (optional)
     * @param minCaffeine The minimum amount of caffeine in milligrams the drink must have per serving. (optional)
     * @param maxCaffeine The maximum amount of caffeine in milligrams the drink can have per serving. (optional)
     * @param sort The attribute by which to sort the drinks. (optional)
     * @param sortDirection Whether to sort ascending or descending (ASC or DESC). (optional)
     * @param offset The number of drinks to skip, between 0 and 90. (optional)
     * @param number The number of drinks, between 1 and 10. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-drinks-api/">Search Drinks API Documentation</a>
     */
    public okhttp3.Call searchDrinksAPICall(String query, String glassTypes, String flavors, String diet, String includeIngredients, String excludeIngredients, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minAlcoholPercent, Double maxAlcoholPercent, Double minCaffeine, Double maxCaffeine, String sort, String sortDirection, Integer offset, Integer number, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/search-drinks";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (query != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("query", query));
        }

        if (glassTypes != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("glass-types", glassTypes));
        }

        if (flavors != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("flavors", flavors));
        }

        if (diet != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("diet", diet));
        }

        if (includeIngredients != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("include-ingredients", includeIngredients));
        }

        if (excludeIngredients != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("exclude-ingredients", excludeIngredients));
        }

        if (minCalories != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-calories", minCalories));
        }

        if (maxCalories != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-calories", maxCalories));
        }

        if (minCarbs != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-carbs", minCarbs));
        }

        if (maxCarbs != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-carbs", maxCarbs));
        }

        if (minProtein != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-protein", minProtein));
        }

        if (maxProtein != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-protein", maxProtein));
        }

        if (minFat != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-fat", minFat));
        }

        if (maxFat != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-fat", maxFat));
        }

        if (minAlcoholPercent != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-alcohol-percent", minAlcoholPercent));
        }

        if (maxAlcoholPercent != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-alcohol-percent", maxAlcoholPercent));
        }

        if (minCaffeine != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-caffeine", minCaffeine));
        }

        if (maxCaffeine != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-caffeine", maxCaffeine));
        }

        if (sort != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("sort", sort));
        }

        if (sortDirection != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("sort-direction", sortDirection));
        }

        if (offset != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("offset", offset));
        }

        if (number != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("number", number));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "apiKey", "headerApiKey" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call searchDrinksAPIValidateBeforeCall(String query, String glassTypes, String flavors, String diet, String includeIngredients, String excludeIngredients, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minAlcoholPercent, Double maxAlcoholPercent, Double minCaffeine, Double maxCaffeine, String sort, String sortDirection, Integer offset, Integer number, final ApiCallback _callback) throws ApiException {
        return searchDrinksAPICall(query, glassTypes, flavors, diet, includeIngredients, excludeIngredients, minCalories, maxCalories, minCarbs, maxCarbs, minProtein, maxProtein, minFat, maxFat, minAlcoholPercent, maxAlcoholPercent, minCaffeine, maxCaffeine, sort, sortDirection, offset, number, _callback);

    }

    /**
     * Search Drinks API
     * Search for drinks by title, ingredients, flavor, type of glass, alcohol content, and more.
     * @param query The search query. (optional)
     * @param glassTypes A comma-separated list (interpreted as OR) of glass types that the drink should be served in. (optional)
     * @param flavors A comma-separated list (interpreted as AND) of dominant flavors in the drink. (optional)
     * @param diet The diet the drink must adhere to. One of the following: paleo,primal,grain-free,vegan,vegetarian. (optional)
     * @param includeIngredients A comma-separated list of ingredients that should/must be used in the drinks. (optional)
     * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the drinks must not contain. (optional)
     * @param minCalories The minimum amount of calories the drink must have per serving. (optional)
     * @param maxCalories The maximum amount of calories the drink can have per serving. (optional)
     * @param minCarbs The minimum amount of carbohydrates in grams the drink must have per serving. (optional)
     * @param maxCarbs The maximum amount of carbohydrates in grams the drink can have per serving. (optional)
     * @param minProtein The minimum amount of protein in grams the drink must have per serving. (optional)
     * @param maxProtein The maximum amount of protein in grams the drink can have per serving. (optional)
     * @param minFat The minimum amount of fat in grams the drink must have per serving. (optional)
     * @param maxFat The maximum amount of fat in grams the drink can have per serving. (optional)
     * @param minAlcoholPercent The minimum alcohol percentage the drink must have. (optional)
     * @param maxAlcoholPercent The maximum alcohol percentage the drink can have. (optional)
     * @param minCaffeine The minimum amount of caffeine in milligrams the drink must have per serving. (optional)
     * @param maxCaffeine The maximum amount of caffeine in milligrams the drink can have per serving. (optional)
     * @param sort The attribute by which to sort the drinks. (optional)
     * @param sortDirection Whether to sort ascending or descending (ASC or DESC). (optional)
     * @param offset The number of drinks to skip, between 0 and 90. (optional)
     * @param number The number of drinks, between 1 and 10. (optional)
     * @return SearchDrinksAPI200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-drinks-api/">Search Drinks API Documentation</a>
     */
    public SearchDrinksAPI200Response searchDrinksAPI(String query, String glassTypes, String flavors, String diet, String includeIngredients, String excludeIngredients, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minAlcoholPercent, Double maxAlcoholPercent, Double minCaffeine, Double maxCaffeine, String sort, String sortDirection, Integer offset, Integer number) throws ApiException {
        ApiResponse<SearchDrinksAPI200Response> localVarResp = searchDrinksAPIWithHttpInfo(query, glassTypes, flavors, diet, includeIngredients, excludeIngredients, minCalories, maxCalories, minCarbs, maxCarbs, minProtein, maxProtein, minFat, maxFat, minAlcoholPercent, maxAlcoholPercent, minCaffeine, maxCaffeine, sort, sortDirection, offset, number);
        return localVarResp.getData();
    }

    /**
     * Search Drinks API
     * Search for drinks by title, ingredients, flavor, type of glass, alcohol content, and more.
     * @param query The search query. (optional)
     * @param glassTypes A comma-separated list (interpreted as OR) of glass types that the drink should be served in. (optional)
     * @param flavors A comma-separated list (interpreted as AND) of dominant flavors in the drink. (optional)
     * @param diet The diet the drink must adhere to. One of the following: paleo,primal,grain-free,vegan,vegetarian. (optional)
     * @param includeIngredients A comma-separated list of ingredients that should/must be used in the drinks. (optional)
     * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the drinks must not contain. (optional)
     * @param minCalories The minimum amount of calories the drink must have per serving. (optional)
     * @param maxCalories The maximum amount of calories the drink can have per serving. (optional)
     * @param minCarbs The minimum amount of carbohydrates in grams the drink must have per serving. (optional)
     * @param maxCarbs The maximum amount of carbohydrates in grams the drink can have per serving. (optional)
     * @param minProtein The minimum amount of protein in grams the drink must have per serving. (optional)
     * @param maxProtein The maximum amount of protein in grams the drink can have per serving. (optional)
     * @param minFat The minimum amount of fat in grams the drink must have per serving. (optional)
     * @param maxFat The maximum amount of fat in grams the drink can have per serving. (optional)
     * @param minAlcoholPercent The minimum alcohol percentage the drink must have. (optional)
     * @param maxAlcoholPercent The maximum alcohol percentage the drink can have. (optional)
     * @param minCaffeine The minimum amount of caffeine in milligrams the drink must have per serving. (optional)
     * @param maxCaffeine The maximum amount of caffeine in milligrams the drink can have per serving. (optional)
     * @param sort The attribute by which to sort the drinks. (optional)
     * @param sortDirection Whether to sort ascending or descending (ASC or DESC). (optional)
     * @param offset The number of drinks to skip, between 0 and 90. (optional)
     * @param number The number of drinks, between 1 and 10. (optional)
     * @return ApiResponse&lt;SearchDrinksAPI200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-drinks-api/">Search Drinks API Documentation</a>
     */
    public ApiResponse<SearchDrinksAPI200Response> searchDrinksAPIWithHttpInfo(String query, String glassTypes, String flavors, String diet, String includeIngredients, String excludeIngredients, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minAlcoholPercent, Double maxAlcoholPercent, Double minCaffeine, Double maxCaffeine, String sort, String sortDirection, Integer offset, Integer number) throws ApiException {
        okhttp3.Call localVarCall = searchDrinksAPIValidateBeforeCall(query, glassTypes, flavors, diet, includeIngredients, excludeIngredients, minCalories, maxCalories, minCarbs, maxCarbs, minProtein, maxProtein, minFat, maxFat, minAlcoholPercent, maxAlcoholPercent, minCaffeine, maxCaffeine, sort, sortDirection, offset, number, null);
        Type localVarReturnType = new TypeToken<SearchDrinksAPI200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Search Drinks API (asynchronously)
     * Search for drinks by title, ingredients, flavor, type of glass, alcohol content, and more.
     * @param query The search query. (optional)
     * @param glassTypes A comma-separated list (interpreted as OR) of glass types that the drink should be served in. (optional)
     * @param flavors A comma-separated list (interpreted as AND) of dominant flavors in the drink. (optional)
     * @param diet The diet the drink must adhere to. One of the following: paleo,primal,grain-free,vegan,vegetarian. (optional)
     * @param includeIngredients A comma-separated list of ingredients that should/must be used in the drinks. (optional)
     * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the drinks must not contain. (optional)
     * @param minCalories The minimum amount of calories the drink must have per serving. (optional)
     * @param maxCalories The maximum amount of calories the drink can have per serving. (optional)
     * @param minCarbs The minimum amount of carbohydrates in grams the drink must have per serving. (optional)
     * @param maxCarbs The maximum amount of carbohydrates in grams the drink can have per serving. (optional)
     * @param minProtein The minimum amount of protein in grams the drink must have per serving. (optional)
     * @param maxProtein The maximum amount of protein in grams the drink can have per serving. (optional)
     * @param minFat The minimum amount of fat in grams the drink must have per serving. (optional)
     * @param maxFat The maximum amount of fat in grams the drink can have per serving. (optional)
     * @param minAlcoholPercent The minimum alcohol percentage the drink must have. (optional)
     * @param maxAlcoholPercent The maximum alcohol percentage the drink can have. (optional)
     * @param minCaffeine The minimum amount of caffeine in milligrams the drink must have per serving. (optional)
     * @param maxCaffeine The maximum amount of caffeine in milligrams the drink can have per serving. (optional)
     * @param sort The attribute by which to sort the drinks. (optional)
     * @param sortDirection Whether to sort ascending or descending (ASC or DESC). (optional)
     * @param offset The number of drinks to skip, between 0 and 90. (optional)
     * @param number The number of drinks, between 1 and 10. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-drinks-api/">Search Drinks API Documentation</a>
     */
    public okhttp3.Call searchDrinksAPIAsync(String query, String glassTypes, String flavors, String diet, String includeIngredients, String excludeIngredients, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minAlcoholPercent, Double maxAlcoholPercent, Double minCaffeine, Double maxCaffeine, String sort, String sortDirection, Integer offset, Integer number, final ApiCallback<SearchDrinksAPI200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = searchDrinksAPIValidateBeforeCall(query, glassTypes, flavors, diet, includeIngredients, excludeIngredients, minCalories, maxCalories, minCarbs, maxCarbs, minProtein, maxProtein, minFat, maxFat, minAlcoholPercent, maxAlcoholPercent, minCaffeine, maxCaffeine, sort, sortDirection, offset, number, _callback);
        Type localVarReturnType = new TypeToken<SearchDrinksAPI200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for searchRecipesAPI
     * @param query The search query. (optional)
     * @param cuisines The cuisine(s) of the recipes. One or more, comma-separated (will be interpreted as &#39;OR&#39;). (optional)
     * @param excludeCuisines The cuisine(s) the recipes must not match. One or more, comma-separated (will be interpreted as &#39;AND&#39;). (optional)
     * @param mealType The type of the recipe, one of: main course,side dish,dessert,appetizer,salad,bread,breakfast,soup,beverage,sauce,drink. (optional)
     * @param diet The diet the recipes must adhere to. One of the following: paleo,primal,grain-free,pescetarian,lacto vegetarian,ovo vegetarian,vegan,vegetarian. (optional)
     * @param intolerances A comma-separated list of intolerances. All recipes returned must not contain ingredients that are not suitable for people with the intolerances entered. (optional)
     * @param equipment The equipment required. Multiple values will be interpreted as &#39;OR&#39;. (optional)
     * @param includeIngredients A comma-separated list of ingredients that should/must be used in the recipes. (optional)
     * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the recipes must not contain. (optional)
     * @param fillIngredients Add information about the ingredients and whether they are used or missing in relation to the query. (optional)
     * @param addRecipeInformation If set to true, you get more information about the recipes returned. (optional)
     * @param maxTime The maximum time in minutes it should take to prepare and cook the recipe. (optional)
     * @param minServings The minimum amount of servings the recipe is for. (optional)
     * @param maxServings The maximum amount of servings the recipe is for. (optional)
     * @param minCalories The minimum amount of calories the recipe must have per serving. (optional)
     * @param maxCalories The maximum amount of calories the recipe can have per serving. (optional)
     * @param minCarbs The minimum amount of carbohydrates in grams the recipe must have per serving. (optional)
     * @param maxCarbs The maximum amount of carbohydrates in grams the recipe can have per serving. (optional)
     * @param minProtein The minimum amount of protein in grams the recipe must have per serving. (optional)
     * @param maxProtein The maximum amount of protein in grams the recipe can have per serving. (optional)
     * @param minFat The minimum amount of fat in grams the recipe must have per serving. (optional)
     * @param maxFat The maximum amount of fat in grams the recipe can have per serving. (optional)
     * @param minSugar The minimum amount of sugar in grams the recipe must have per serving. (optional)
     * @param maxSugar The maximum amount of sugar in grams the recipe can have per serving. (optional)
     * @param minFiber The minimum amount of fiber in grams the recipe must have per serving. (optional)
     * @param maxFiber The maximum amount of fiber in grams the recipe can have per serving. (optional)
     * @param minFolate The minimum amount of folate in micrograms the recipe must have per serving. (optional)
     * @param maxFolate The maximum amount of folate in micrograms the recipe can have per serving. (optional)
     * @param minFolicAcid The minimum amount of folic acid in micrograms the recipe must have per serving. (optional)
     * @param maxFolicAcid The maximum amount of folic acid in micrograms the recipe can have per serving. (optional)
     * @param minIodine The minimum amount of iodine in micrograms the recipe must have per serving. (optional)
     * @param maxIodine The maximum amount of iodine in micrograms the recipe can have per serving. (optional)
     * @param minIron The minimum amount of iron in milligrams the recipe must have per serving. (optional)
     * @param maxIron The maximum amount of iron in milligrams the recipe can have per serving. (optional)
     * @param minZinc The minimum amount of zinc in milligrams the recipe must have per serving. (optional)
     * @param maxZinc The maximum amount of zinc in milligrams the recipe can have per serving. (optional)
     * @param minMagnesium The minimum amount of magnesium in milligrams the recipe must have per serving. (optional)
     * @param maxMagnesium The maximum amount of magnesium in milligrams the recipe can have per serving. (optional)
     * @param minManganese The minimum amount of manganese in milligrams the recipe must have per serving. (optional)
     * @param maxManganese The maximum amount of manganese in milligrams the recipe can have per serving. (optional)
     * @param minPhosphorus The minimum amount of phosphorus in milligrams the recipe must have per serving. (optional)
     * @param maxPhosphorus The maximum amount of phosphorus in milligrams the recipe can have per serving. (optional)
     * @param minPotassium The minimum amount of potassium in milligrams the recipe must have per serving. (optional)
     * @param maxPotassium The maximum amount of potassium in milligrams the recipe can have per serving. (optional)
     * @param minSodium The minimum amount of sodium in milligrams the recipe must have per serving. (optional)
     * @param maxSodium The maximum amount of sodium in milligrams the recipe can have per serving. (optional)
     * @param minSelenium The minimum amount of selenium in micrograms the recipe must have per serving. (optional)
     * @param maxSelenium The maximum amount of selenium in micrograms the recipe can have per serving. (optional)
     * @param minCopper The minimum amount of copper in milligrams the recipe must have per serving. (optional)
     * @param maxCopper The maximum amount of copper in milligrams the recipe can have per serving. (optional)
     * @param minCalcium The minimum amount of calcium in milligrams the recipe must have per serving. (optional)
     * @param maxCalcium The maximum amount of calcium in milligrams the recipe can have per serving. (optional)
     * @param minCholine The minimum amount of choline in milligrams the recipe must have per serving. (optional)
     * @param maxCholine The maximum amount of choline in milligrams the recipe can have per serving. (optional)
     * @param minCholesterol The minimum amount of cholesterol in milligrams the recipe must have per serving. (optional)
     * @param maxCholesterol The maximum amount of cholesterol in milligrams the recipe can have per serving. (optional)
     * @param minFluoride The minimum amount of fluoride in milligrams the recipe must have per serving. (optional)
     * @param maxFluoride The maximum amount of fluoride in milligrams the recipe can have per serving. (optional)
     * @param minAlcohol The minimum amount of alcohol in grams the recipe must have per serving. (optional)
     * @param maxAlcohol The maximum amount of alcohol in grams the recipe can have per serving. (optional)
     * @param minCaffeine The minimum amount of caffeine in milligrams the recipe must have per serving. (optional)
     * @param maxCaffeine The maximum amount of caffeine in milligrams the recipe can have per serving. (optional)
     * @param minSaturatedFat The minimum amount of saturated fat in grams the recipe must have per serving. (optional)
     * @param maxSaturatedFat The maximum amount of saturated fat in grams the recipe can have per serving. (optional)
     * @param minVitaminA The minimum amount of Vitamin A in IU the recipe must have per serving. (optional)
     * @param maxVitaminA The maximum amount of Vitamin A in IU the recipe can have per serving. (optional)
     * @param minVitaminC The minimum amount of Vitamin C in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminC The maximum amount of Vitamin C in milligrams the recipe can have per serving. (optional)
     * @param minVitaminD The minimum amount of Vitamin D in micrograms the recipe must have per serving. (optional)
     * @param maxVitaminD The maximum amount of Vitamin D in micrograms the recipe can have per serving. (optional)
     * @param minVitaminE The minimum amount of Vitamin E in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminE The maximum amount of Vitamin E in milligrams the recipe can have per serving. (optional)
     * @param minVitaminK The minimum amount of Vitamin K in micrograms the recipe must have per serving. (optional)
     * @param maxVitaminK The maximum amount of Vitamin K in micrograms the recipe can have per serving. (optional)
     * @param minVitaminB1 The minimum amount of Vitamin B1 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB1 The maximum amount of Vitamin B1 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB2 The minimum amount of Vitamin B2 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB2 The maximum amount of Vitamin B2 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB3 The minimum amount of Vitamin B3 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB3 The maximum amount of Vitamin B3 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB5 The minimum amount of Vitamin B5 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB5 The maximum amount of Vitamin B5 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB6 The minimum amount of Vitamin B6 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB6 The maximum amount of Vitamin B6 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB12 The minimum amount of Vitamin B12 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB12 The maximum amount of Vitamin B12 in milligrams the recipe can have per serving. (optional)
     * @param sort The strategy to sort recipes by. (optional)
     * @param sortDirection Whether to sort ascending or descending (ASC or DESC). (optional)
     * @param offset The number of recipes to skip, between 0 and 900. (optional)
     * @param number The number of recipes, between 1 and 100. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-recipes-api/">Search Recipes API Documentation</a>
     */
    public okhttp3.Call searchRecipesAPICall(String query, String cuisines, String excludeCuisines, String mealType, String diet, String intolerances, String equipment, String includeIngredients, String excludeIngredients, Boolean fillIngredients, Boolean addRecipeInformation, Integer maxTime, Integer minServings, Integer maxServings, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minSugar, Double maxSugar, Double minFiber, Double maxFiber, Double minFolate, Double maxFolate, Double minFolicAcid, Double maxFolicAcid, Double minIodine, Double maxIodine, Double minIron, Double maxIron, Double minZinc, Double maxZinc, Double minMagnesium, Double maxMagnesium, Double minManganese, Double maxManganese, Double minPhosphorus, Double maxPhosphorus, Double minPotassium, Double maxPotassium, Double minSodium, Double maxSodium, Double minSelenium, Double maxSelenium, Double minCopper, Double maxCopper, Double minCalcium, Double maxCalcium, Double minCholine, Double maxCholine, Double minCholesterol, Double maxCholesterol, Double minFluoride, Double maxFluoride, Double minAlcohol, Double maxAlcohol, Double minCaffeine, Double maxCaffeine, Double minSaturatedFat, Double maxSaturatedFat, Double minVitaminA, Double maxVitaminA, Double minVitaminC, Double maxVitaminC, Double minVitaminD, Double maxVitaminD, Double minVitaminE, Double maxVitaminE, Double minVitaminK, Double maxVitaminK, Double minVitaminB1, Double maxVitaminB1, Double minVitaminB2, Double maxVitaminB2, Double minVitaminB3, Double maxVitaminB3, Double minVitaminB5, Double maxVitaminB5, Double minVitaminB6, Double maxVitaminB6, Double minVitaminB12, Double maxVitaminB12, String sort, String sortDirection, Integer offset, Integer number, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/search-recipes";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (query != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("query", query));
        }

        if (cuisines != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("cuisines", cuisines));
        }

        if (excludeCuisines != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("exclude-cuisines", excludeCuisines));
        }

        if (mealType != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("meal-type", mealType));
        }

        if (diet != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("diet", diet));
        }

        if (intolerances != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("intolerances", intolerances));
        }

        if (equipment != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("equipment", equipment));
        }

        if (includeIngredients != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("include-ingredients", includeIngredients));
        }

        if (excludeIngredients != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("exclude-ingredients", excludeIngredients));
        }

        if (fillIngredients != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("fill-ingredients", fillIngredients));
        }

        if (addRecipeInformation != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("add-recipe-information", addRecipeInformation));
        }

        if (maxTime != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-time", maxTime));
        }

        if (minServings != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-servings", minServings));
        }

        if (maxServings != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-servings", maxServings));
        }

        if (minCalories != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-calories", minCalories));
        }

        if (maxCalories != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-calories", maxCalories));
        }

        if (minCarbs != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-carbs", minCarbs));
        }

        if (maxCarbs != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-carbs", maxCarbs));
        }

        if (minProtein != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-protein", minProtein));
        }

        if (maxProtein != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-protein", maxProtein));
        }

        if (minFat != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-fat", minFat));
        }

        if (maxFat != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-fat", maxFat));
        }

        if (minSugar != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-sugar", minSugar));
        }

        if (maxSugar != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-sugar", maxSugar));
        }

        if (minFiber != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-fiber", minFiber));
        }

        if (maxFiber != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-fiber", maxFiber));
        }

        if (minFolate != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-folate", minFolate));
        }

        if (maxFolate != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-folate", maxFolate));
        }

        if (minFolicAcid != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-folic-acid", minFolicAcid));
        }

        if (maxFolicAcid != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-folic-acid", maxFolicAcid));
        }

        if (minIodine != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-iodine", minIodine));
        }

        if (maxIodine != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-iodine", maxIodine));
        }

        if (minIron != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-iron", minIron));
        }

        if (maxIron != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-iron", maxIron));
        }

        if (minZinc != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-zinc", minZinc));
        }

        if (maxZinc != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-zinc", maxZinc));
        }

        if (minMagnesium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-magnesium", minMagnesium));
        }

        if (maxMagnesium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-magnesium", maxMagnesium));
        }

        if (minManganese != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-manganese", minManganese));
        }

        if (maxManganese != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-manganese", maxManganese));
        }

        if (minPhosphorus != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-phosphorus", minPhosphorus));
        }

        if (maxPhosphorus != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-phosphorus", maxPhosphorus));
        }

        if (minPotassium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-potassium", minPotassium));
        }

        if (maxPotassium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-potassium", maxPotassium));
        }

        if (minSodium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-sodium", minSodium));
        }

        if (maxSodium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-sodium", maxSodium));
        }

        if (minSelenium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-selenium", minSelenium));
        }

        if (maxSelenium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-selenium", maxSelenium));
        }

        if (minCopper != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-copper", minCopper));
        }

        if (maxCopper != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-copper", maxCopper));
        }

        if (minCalcium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-calcium", minCalcium));
        }

        if (maxCalcium != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-calcium", maxCalcium));
        }

        if (minCholine != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-choline", minCholine));
        }

        if (maxCholine != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-choline", maxCholine));
        }

        if (minCholesterol != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-cholesterol", minCholesterol));
        }

        if (maxCholesterol != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-cholesterol", maxCholesterol));
        }

        if (minFluoride != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-fluoride", minFluoride));
        }

        if (maxFluoride != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-fluoride", maxFluoride));
        }

        if (minAlcohol != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-alcohol", minAlcohol));
        }

        if (maxAlcohol != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-alcohol", maxAlcohol));
        }

        if (minCaffeine != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-caffeine", minCaffeine));
        }

        if (maxCaffeine != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-caffeine", maxCaffeine));
        }

        if (minSaturatedFat != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-saturated-fat", minSaturatedFat));
        }

        if (maxSaturatedFat != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-saturated-fat", maxSaturatedFat));
        }

        if (minVitaminA != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-a", minVitaminA));
        }

        if (maxVitaminA != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-a", maxVitaminA));
        }

        if (minVitaminC != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-c", minVitaminC));
        }

        if (maxVitaminC != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-c", maxVitaminC));
        }

        if (minVitaminD != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-d", minVitaminD));
        }

        if (maxVitaminD != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-d", maxVitaminD));
        }

        if (minVitaminE != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-e", minVitaminE));
        }

        if (maxVitaminE != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-e", maxVitaminE));
        }

        if (minVitaminK != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-k", minVitaminK));
        }

        if (maxVitaminK != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-k", maxVitaminK));
        }

        if (minVitaminB1 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-b1", minVitaminB1));
        }

        if (maxVitaminB1 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-b1", maxVitaminB1));
        }

        if (minVitaminB2 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-b2", minVitaminB2));
        }

        if (maxVitaminB2 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-b2", maxVitaminB2));
        }

        if (minVitaminB3 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-b3", minVitaminB3));
        }

        if (maxVitaminB3 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-b3", maxVitaminB3));
        }

        if (minVitaminB5 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-b5", minVitaminB5));
        }

        if (maxVitaminB5 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-b5", maxVitaminB5));
        }

        if (minVitaminB6 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-b6", minVitaminB6));
        }

        if (maxVitaminB6 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-b6", maxVitaminB6));
        }

        if (minVitaminB12 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-vitamin-b12", minVitaminB12));
        }

        if (maxVitaminB12 != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("max-vitamin-b12", maxVitaminB12));
        }

        if (sort != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("sort", sort));
        }

        if (sortDirection != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("sort-direction", sortDirection));
        }

        if (offset != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("offset", offset));
        }

        if (number != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("number", number));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "apiKey", "headerApiKey" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call searchRecipesAPIValidateBeforeCall(String query, String cuisines, String excludeCuisines, String mealType, String diet, String intolerances, String equipment, String includeIngredients, String excludeIngredients, Boolean fillIngredients, Boolean addRecipeInformation, Integer maxTime, Integer minServings, Integer maxServings, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minSugar, Double maxSugar, Double minFiber, Double maxFiber, Double minFolate, Double maxFolate, Double minFolicAcid, Double maxFolicAcid, Double minIodine, Double maxIodine, Double minIron, Double maxIron, Double minZinc, Double maxZinc, Double minMagnesium, Double maxMagnesium, Double minManganese, Double maxManganese, Double minPhosphorus, Double maxPhosphorus, Double minPotassium, Double maxPotassium, Double minSodium, Double maxSodium, Double minSelenium, Double maxSelenium, Double minCopper, Double maxCopper, Double minCalcium, Double maxCalcium, Double minCholine, Double maxCholine, Double minCholesterol, Double maxCholesterol, Double minFluoride, Double maxFluoride, Double minAlcohol, Double maxAlcohol, Double minCaffeine, Double maxCaffeine, Double minSaturatedFat, Double maxSaturatedFat, Double minVitaminA, Double maxVitaminA, Double minVitaminC, Double maxVitaminC, Double minVitaminD, Double maxVitaminD, Double minVitaminE, Double maxVitaminE, Double minVitaminK, Double maxVitaminK, Double minVitaminB1, Double maxVitaminB1, Double minVitaminB2, Double maxVitaminB2, Double minVitaminB3, Double maxVitaminB3, Double minVitaminB5, Double maxVitaminB5, Double minVitaminB6, Double maxVitaminB6, Double minVitaminB12, Double maxVitaminB12, String sort, String sortDirection, Integer offset, Integer number, final ApiCallback _callback) throws ApiException {
        return searchRecipesAPICall(query, cuisines, excludeCuisines, mealType, diet, intolerances, equipment, includeIngredients, excludeIngredients, fillIngredients, addRecipeInformation, maxTime, minServings, maxServings, minCalories, maxCalories, minCarbs, maxCarbs, minProtein, maxProtein, minFat, maxFat, minSugar, maxSugar, minFiber, maxFiber, minFolate, maxFolate, minFolicAcid, maxFolicAcid, minIodine, maxIodine, minIron, maxIron, minZinc, maxZinc, minMagnesium, maxMagnesium, minManganese, maxManganese, minPhosphorus, maxPhosphorus, minPotassium, maxPotassium, minSodium, maxSodium, minSelenium, maxSelenium, minCopper, maxCopper, minCalcium, maxCalcium, minCholine, maxCholine, minCholesterol, maxCholesterol, minFluoride, maxFluoride, minAlcohol, maxAlcohol, minCaffeine, maxCaffeine, minSaturatedFat, maxSaturatedFat, minVitaminA, maxVitaminA, minVitaminC, maxVitaminC, minVitaminD, maxVitaminD, minVitaminE, maxVitaminE, minVitaminK, maxVitaminK, minVitaminB1, maxVitaminB1, minVitaminB2, maxVitaminB2, minVitaminB3, maxVitaminB3, minVitaminB5, maxVitaminB5, minVitaminB6, maxVitaminB6, minVitaminB12, maxVitaminB12, sort, sortDirection, offset, number, _callback);

    }

    /**
     * Search Recipes API
     * Search and filter thousands of recipes with natural language, e.g. pasta recipes without mushrooms but with truffles. You can filter by ingredients, diet, cuisine, meal type, macro and micro nutrition, intolerances, and much more.
     * @param query The search query. (optional)
     * @param cuisines The cuisine(s) of the recipes. One or more, comma-separated (will be interpreted as &#39;OR&#39;). (optional)
     * @param excludeCuisines The cuisine(s) the recipes must not match. One or more, comma-separated (will be interpreted as &#39;AND&#39;). (optional)
     * @param mealType The type of the recipe, one of: main course,side dish,dessert,appetizer,salad,bread,breakfast,soup,beverage,sauce,drink. (optional)
     * @param diet The diet the recipes must adhere to. One of the following: paleo,primal,grain-free,pescetarian,lacto vegetarian,ovo vegetarian,vegan,vegetarian. (optional)
     * @param intolerances A comma-separated list of intolerances. All recipes returned must not contain ingredients that are not suitable for people with the intolerances entered. (optional)
     * @param equipment The equipment required. Multiple values will be interpreted as &#39;OR&#39;. (optional)
     * @param includeIngredients A comma-separated list of ingredients that should/must be used in the recipes. (optional)
     * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the recipes must not contain. (optional)
     * @param fillIngredients Add information about the ingredients and whether they are used or missing in relation to the query. (optional)
     * @param addRecipeInformation If set to true, you get more information about the recipes returned. (optional)
     * @param maxTime The maximum time in minutes it should take to prepare and cook the recipe. (optional)
     * @param minServings The minimum amount of servings the recipe is for. (optional)
     * @param maxServings The maximum amount of servings the recipe is for. (optional)
     * @param minCalories The minimum amount of calories the recipe must have per serving. (optional)
     * @param maxCalories The maximum amount of calories the recipe can have per serving. (optional)
     * @param minCarbs The minimum amount of carbohydrates in grams the recipe must have per serving. (optional)
     * @param maxCarbs The maximum amount of carbohydrates in grams the recipe can have per serving. (optional)
     * @param minProtein The minimum amount of protein in grams the recipe must have per serving. (optional)
     * @param maxProtein The maximum amount of protein in grams the recipe can have per serving. (optional)
     * @param minFat The minimum amount of fat in grams the recipe must have per serving. (optional)
     * @param maxFat The maximum amount of fat in grams the recipe can have per serving. (optional)
     * @param minSugar The minimum amount of sugar in grams the recipe must have per serving. (optional)
     * @param maxSugar The maximum amount of sugar in grams the recipe can have per serving. (optional)
     * @param minFiber The minimum amount of fiber in grams the recipe must have per serving. (optional)
     * @param maxFiber The maximum amount of fiber in grams the recipe can have per serving. (optional)
     * @param minFolate The minimum amount of folate in micrograms the recipe must have per serving. (optional)
     * @param maxFolate The maximum amount of folate in micrograms the recipe can have per serving. (optional)
     * @param minFolicAcid The minimum amount of folic acid in micrograms the recipe must have per serving. (optional)
     * @param maxFolicAcid The maximum amount of folic acid in micrograms the recipe can have per serving. (optional)
     * @param minIodine The minimum amount of iodine in micrograms the recipe must have per serving. (optional)
     * @param maxIodine The maximum amount of iodine in micrograms the recipe can have per serving. (optional)
     * @param minIron The minimum amount of iron in milligrams the recipe must have per serving. (optional)
     * @param maxIron The maximum amount of iron in milligrams the recipe can have per serving. (optional)
     * @param minZinc The minimum amount of zinc in milligrams the recipe must have per serving. (optional)
     * @param maxZinc The maximum amount of zinc in milligrams the recipe can have per serving. (optional)
     * @param minMagnesium The minimum amount of magnesium in milligrams the recipe must have per serving. (optional)
     * @param maxMagnesium The maximum amount of magnesium in milligrams the recipe can have per serving. (optional)
     * @param minManganese The minimum amount of manganese in milligrams the recipe must have per serving. (optional)
     * @param maxManganese The maximum amount of manganese in milligrams the recipe can have per serving. (optional)
     * @param minPhosphorus The minimum amount of phosphorus in milligrams the recipe must have per serving. (optional)
     * @param maxPhosphorus The maximum amount of phosphorus in milligrams the recipe can have per serving. (optional)
     * @param minPotassium The minimum amount of potassium in milligrams the recipe must have per serving. (optional)
     * @param maxPotassium The maximum amount of potassium in milligrams the recipe can have per serving. (optional)
     * @param minSodium The minimum amount of sodium in milligrams the recipe must have per serving. (optional)
     * @param maxSodium The maximum amount of sodium in milligrams the recipe can have per serving. (optional)
     * @param minSelenium The minimum amount of selenium in micrograms the recipe must have per serving. (optional)
     * @param maxSelenium The maximum amount of selenium in micrograms the recipe can have per serving. (optional)
     * @param minCopper The minimum amount of copper in milligrams the recipe must have per serving. (optional)
     * @param maxCopper The maximum amount of copper in milligrams the recipe can have per serving. (optional)
     * @param minCalcium The minimum amount of calcium in milligrams the recipe must have per serving. (optional)
     * @param maxCalcium The maximum amount of calcium in milligrams the recipe can have per serving. (optional)
     * @param minCholine The minimum amount of choline in milligrams the recipe must have per serving. (optional)
     * @param maxCholine The maximum amount of choline in milligrams the recipe can have per serving. (optional)
     * @param minCholesterol The minimum amount of cholesterol in milligrams the recipe must have per serving. (optional)
     * @param maxCholesterol The maximum amount of cholesterol in milligrams the recipe can have per serving. (optional)
     * @param minFluoride The minimum amount of fluoride in milligrams the recipe must have per serving. (optional)
     * @param maxFluoride The maximum amount of fluoride in milligrams the recipe can have per serving. (optional)
     * @param minAlcohol The minimum amount of alcohol in grams the recipe must have per serving. (optional)
     * @param maxAlcohol The maximum amount of alcohol in grams the recipe can have per serving. (optional)
     * @param minCaffeine The minimum amount of caffeine in milligrams the recipe must have per serving. (optional)
     * @param maxCaffeine The maximum amount of caffeine in milligrams the recipe can have per serving. (optional)
     * @param minSaturatedFat The minimum amount of saturated fat in grams the recipe must have per serving. (optional)
     * @param maxSaturatedFat The maximum amount of saturated fat in grams the recipe can have per serving. (optional)
     * @param minVitaminA The minimum amount of Vitamin A in IU the recipe must have per serving. (optional)
     * @param maxVitaminA The maximum amount of Vitamin A in IU the recipe can have per serving. (optional)
     * @param minVitaminC The minimum amount of Vitamin C in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminC The maximum amount of Vitamin C in milligrams the recipe can have per serving. (optional)
     * @param minVitaminD The minimum amount of Vitamin D in micrograms the recipe must have per serving. (optional)
     * @param maxVitaminD The maximum amount of Vitamin D in micrograms the recipe can have per serving. (optional)
     * @param minVitaminE The minimum amount of Vitamin E in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminE The maximum amount of Vitamin E in milligrams the recipe can have per serving. (optional)
     * @param minVitaminK The minimum amount of Vitamin K in micrograms the recipe must have per serving. (optional)
     * @param maxVitaminK The maximum amount of Vitamin K in micrograms the recipe can have per serving. (optional)
     * @param minVitaminB1 The minimum amount of Vitamin B1 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB1 The maximum amount of Vitamin B1 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB2 The minimum amount of Vitamin B2 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB2 The maximum amount of Vitamin B2 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB3 The minimum amount of Vitamin B3 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB3 The maximum amount of Vitamin B3 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB5 The minimum amount of Vitamin B5 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB5 The maximum amount of Vitamin B5 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB6 The minimum amount of Vitamin B6 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB6 The maximum amount of Vitamin B6 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB12 The minimum amount of Vitamin B12 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB12 The maximum amount of Vitamin B12 in milligrams the recipe can have per serving. (optional)
     * @param sort The strategy to sort recipes by. (optional)
     * @param sortDirection Whether to sort ascending or descending (ASC or DESC). (optional)
     * @param offset The number of recipes to skip, between 0 and 900. (optional)
     * @param number The number of recipes, between 1 and 100. (optional)
     * @return SearchRecipesAPI200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-recipes-api/">Search Recipes API Documentation</a>
     */
    public SearchRecipesAPI200Response searchRecipesAPI(String query, String cuisines, String excludeCuisines, String mealType, String diet, String intolerances, String equipment, String includeIngredients, String excludeIngredients, Boolean fillIngredients, Boolean addRecipeInformation, Integer maxTime, Integer minServings, Integer maxServings, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minSugar, Double maxSugar, Double minFiber, Double maxFiber, Double minFolate, Double maxFolate, Double minFolicAcid, Double maxFolicAcid, Double minIodine, Double maxIodine, Double minIron, Double maxIron, Double minZinc, Double maxZinc, Double minMagnesium, Double maxMagnesium, Double minManganese, Double maxManganese, Double minPhosphorus, Double maxPhosphorus, Double minPotassium, Double maxPotassium, Double minSodium, Double maxSodium, Double minSelenium, Double maxSelenium, Double minCopper, Double maxCopper, Double minCalcium, Double maxCalcium, Double minCholine, Double maxCholine, Double minCholesterol, Double maxCholesterol, Double minFluoride, Double maxFluoride, Double minAlcohol, Double maxAlcohol, Double minCaffeine, Double maxCaffeine, Double minSaturatedFat, Double maxSaturatedFat, Double minVitaminA, Double maxVitaminA, Double minVitaminC, Double maxVitaminC, Double minVitaminD, Double maxVitaminD, Double minVitaminE, Double maxVitaminE, Double minVitaminK, Double maxVitaminK, Double minVitaminB1, Double maxVitaminB1, Double minVitaminB2, Double maxVitaminB2, Double minVitaminB3, Double maxVitaminB3, Double minVitaminB5, Double maxVitaminB5, Double minVitaminB6, Double maxVitaminB6, Double minVitaminB12, Double maxVitaminB12, String sort, String sortDirection, Integer offset, Integer number) throws ApiException {
        ApiResponse<SearchRecipesAPI200Response> localVarResp = searchRecipesAPIWithHttpInfo(query, cuisines, excludeCuisines, mealType, diet, intolerances, equipment, includeIngredients, excludeIngredients, fillIngredients, addRecipeInformation, maxTime, minServings, maxServings, minCalories, maxCalories, minCarbs, maxCarbs, minProtein, maxProtein, minFat, maxFat, minSugar, maxSugar, minFiber, maxFiber, minFolate, maxFolate, minFolicAcid, maxFolicAcid, minIodine, maxIodine, minIron, maxIron, minZinc, maxZinc, minMagnesium, maxMagnesium, minManganese, maxManganese, minPhosphorus, maxPhosphorus, minPotassium, maxPotassium, minSodium, maxSodium, minSelenium, maxSelenium, minCopper, maxCopper, minCalcium, maxCalcium, minCholine, maxCholine, minCholesterol, maxCholesterol, minFluoride, maxFluoride, minAlcohol, maxAlcohol, minCaffeine, maxCaffeine, minSaturatedFat, maxSaturatedFat, minVitaminA, maxVitaminA, minVitaminC, maxVitaminC, minVitaminD, maxVitaminD, minVitaminE, maxVitaminE, minVitaminK, maxVitaminK, minVitaminB1, maxVitaminB1, minVitaminB2, maxVitaminB2, minVitaminB3, maxVitaminB3, minVitaminB5, maxVitaminB5, minVitaminB6, maxVitaminB6, minVitaminB12, maxVitaminB12, sort, sortDirection, offset, number);
        return localVarResp.getData();
    }

    /**
     * Search Recipes API
     * Search and filter thousands of recipes with natural language, e.g. pasta recipes without mushrooms but with truffles. You can filter by ingredients, diet, cuisine, meal type, macro and micro nutrition, intolerances, and much more.
     * @param query The search query. (optional)
     * @param cuisines The cuisine(s) of the recipes. One or more, comma-separated (will be interpreted as &#39;OR&#39;). (optional)
     * @param excludeCuisines The cuisine(s) the recipes must not match. One or more, comma-separated (will be interpreted as &#39;AND&#39;). (optional)
     * @param mealType The type of the recipe, one of: main course,side dish,dessert,appetizer,salad,bread,breakfast,soup,beverage,sauce,drink. (optional)
     * @param diet The diet the recipes must adhere to. One of the following: paleo,primal,grain-free,pescetarian,lacto vegetarian,ovo vegetarian,vegan,vegetarian. (optional)
     * @param intolerances A comma-separated list of intolerances. All recipes returned must not contain ingredients that are not suitable for people with the intolerances entered. (optional)
     * @param equipment The equipment required. Multiple values will be interpreted as &#39;OR&#39;. (optional)
     * @param includeIngredients A comma-separated list of ingredients that should/must be used in the recipes. (optional)
     * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the recipes must not contain. (optional)
     * @param fillIngredients Add information about the ingredients and whether they are used or missing in relation to the query. (optional)
     * @param addRecipeInformation If set to true, you get more information about the recipes returned. (optional)
     * @param maxTime The maximum time in minutes it should take to prepare and cook the recipe. (optional)
     * @param minServings The minimum amount of servings the recipe is for. (optional)
     * @param maxServings The maximum amount of servings the recipe is for. (optional)
     * @param minCalories The minimum amount of calories the recipe must have per serving. (optional)
     * @param maxCalories The maximum amount of calories the recipe can have per serving. (optional)
     * @param minCarbs The minimum amount of carbohydrates in grams the recipe must have per serving. (optional)
     * @param maxCarbs The maximum amount of carbohydrates in grams the recipe can have per serving. (optional)
     * @param minProtein The minimum amount of protein in grams the recipe must have per serving. (optional)
     * @param maxProtein The maximum amount of protein in grams the recipe can have per serving. (optional)
     * @param minFat The minimum amount of fat in grams the recipe must have per serving. (optional)
     * @param maxFat The maximum amount of fat in grams the recipe can have per serving. (optional)
     * @param minSugar The minimum amount of sugar in grams the recipe must have per serving. (optional)
     * @param maxSugar The maximum amount of sugar in grams the recipe can have per serving. (optional)
     * @param minFiber The minimum amount of fiber in grams the recipe must have per serving. (optional)
     * @param maxFiber The maximum amount of fiber in grams the recipe can have per serving. (optional)
     * @param minFolate The minimum amount of folate in micrograms the recipe must have per serving. (optional)
     * @param maxFolate The maximum amount of folate in micrograms the recipe can have per serving. (optional)
     * @param minFolicAcid The minimum amount of folic acid in micrograms the recipe must have per serving. (optional)
     * @param maxFolicAcid The maximum amount of folic acid in micrograms the recipe can have per serving. (optional)
     * @param minIodine The minimum amount of iodine in micrograms the recipe must have per serving. (optional)
     * @param maxIodine The maximum amount of iodine in micrograms the recipe can have per serving. (optional)
     * @param minIron The minimum amount of iron in milligrams the recipe must have per serving. (optional)
     * @param maxIron The maximum amount of iron in milligrams the recipe can have per serving. (optional)
     * @param minZinc The minimum amount of zinc in milligrams the recipe must have per serving. (optional)
     * @param maxZinc The maximum amount of zinc in milligrams the recipe can have per serving. (optional)
     * @param minMagnesium The minimum amount of magnesium in milligrams the recipe must have per serving. (optional)
     * @param maxMagnesium The maximum amount of magnesium in milligrams the recipe can have per serving. (optional)
     * @param minManganese The minimum amount of manganese in milligrams the recipe must have per serving. (optional)
     * @param maxManganese The maximum amount of manganese in milligrams the recipe can have per serving. (optional)
     * @param minPhosphorus The minimum amount of phosphorus in milligrams the recipe must have per serving. (optional)
     * @param maxPhosphorus The maximum amount of phosphorus in milligrams the recipe can have per serving. (optional)
     * @param minPotassium The minimum amount of potassium in milligrams the recipe must have per serving. (optional)
     * @param maxPotassium The maximum amount of potassium in milligrams the recipe can have per serving. (optional)
     * @param minSodium The minimum amount of sodium in milligrams the recipe must have per serving. (optional)
     * @param maxSodium The maximum amount of sodium in milligrams the recipe can have per serving. (optional)
     * @param minSelenium The minimum amount of selenium in micrograms the recipe must have per serving. (optional)
     * @param maxSelenium The maximum amount of selenium in micrograms the recipe can have per serving. (optional)
     * @param minCopper The minimum amount of copper in milligrams the recipe must have per serving. (optional)
     * @param maxCopper The maximum amount of copper in milligrams the recipe can have per serving. (optional)
     * @param minCalcium The minimum amount of calcium in milligrams the recipe must have per serving. (optional)
     * @param maxCalcium The maximum amount of calcium in milligrams the recipe can have per serving. (optional)
     * @param minCholine The minimum amount of choline in milligrams the recipe must have per serving. (optional)
     * @param maxCholine The maximum amount of choline in milligrams the recipe can have per serving. (optional)
     * @param minCholesterol The minimum amount of cholesterol in milligrams the recipe must have per serving. (optional)
     * @param maxCholesterol The maximum amount of cholesterol in milligrams the recipe can have per serving. (optional)
     * @param minFluoride The minimum amount of fluoride in milligrams the recipe must have per serving. (optional)
     * @param maxFluoride The maximum amount of fluoride in milligrams the recipe can have per serving. (optional)
     * @param minAlcohol The minimum amount of alcohol in grams the recipe must have per serving. (optional)
     * @param maxAlcohol The maximum amount of alcohol in grams the recipe can have per serving. (optional)
     * @param minCaffeine The minimum amount of caffeine in milligrams the recipe must have per serving. (optional)
     * @param maxCaffeine The maximum amount of caffeine in milligrams the recipe can have per serving. (optional)
     * @param minSaturatedFat The minimum amount of saturated fat in grams the recipe must have per serving. (optional)
     * @param maxSaturatedFat The maximum amount of saturated fat in grams the recipe can have per serving. (optional)
     * @param minVitaminA The minimum amount of Vitamin A in IU the recipe must have per serving. (optional)
     * @param maxVitaminA The maximum amount of Vitamin A in IU the recipe can have per serving. (optional)
     * @param minVitaminC The minimum amount of Vitamin C in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminC The maximum amount of Vitamin C in milligrams the recipe can have per serving. (optional)
     * @param minVitaminD The minimum amount of Vitamin D in micrograms the recipe must have per serving. (optional)
     * @param maxVitaminD The maximum amount of Vitamin D in micrograms the recipe can have per serving. (optional)
     * @param minVitaminE The minimum amount of Vitamin E in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminE The maximum amount of Vitamin E in milligrams the recipe can have per serving. (optional)
     * @param minVitaminK The minimum amount of Vitamin K in micrograms the recipe must have per serving. (optional)
     * @param maxVitaminK The maximum amount of Vitamin K in micrograms the recipe can have per serving. (optional)
     * @param minVitaminB1 The minimum amount of Vitamin B1 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB1 The maximum amount of Vitamin B1 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB2 The minimum amount of Vitamin B2 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB2 The maximum amount of Vitamin B2 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB3 The minimum amount of Vitamin B3 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB3 The maximum amount of Vitamin B3 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB5 The minimum amount of Vitamin B5 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB5 The maximum amount of Vitamin B5 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB6 The minimum amount of Vitamin B6 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB6 The maximum amount of Vitamin B6 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB12 The minimum amount of Vitamin B12 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB12 The maximum amount of Vitamin B12 in milligrams the recipe can have per serving. (optional)
     * @param sort The strategy to sort recipes by. (optional)
     * @param sortDirection Whether to sort ascending or descending (ASC or DESC). (optional)
     * @param offset The number of recipes to skip, between 0 and 900. (optional)
     * @param number The number of recipes, between 1 and 100. (optional)
     * @return ApiResponse&lt;SearchRecipesAPI200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-recipes-api/">Search Recipes API Documentation</a>
     */
    public ApiResponse<SearchRecipesAPI200Response> searchRecipesAPIWithHttpInfo(String query, String cuisines, String excludeCuisines, String mealType, String diet, String intolerances, String equipment, String includeIngredients, String excludeIngredients, Boolean fillIngredients, Boolean addRecipeInformation, Integer maxTime, Integer minServings, Integer maxServings, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minSugar, Double maxSugar, Double minFiber, Double maxFiber, Double minFolate, Double maxFolate, Double minFolicAcid, Double maxFolicAcid, Double minIodine, Double maxIodine, Double minIron, Double maxIron, Double minZinc, Double maxZinc, Double minMagnesium, Double maxMagnesium, Double minManganese, Double maxManganese, Double minPhosphorus, Double maxPhosphorus, Double minPotassium, Double maxPotassium, Double minSodium, Double maxSodium, Double minSelenium, Double maxSelenium, Double minCopper, Double maxCopper, Double minCalcium, Double maxCalcium, Double minCholine, Double maxCholine, Double minCholesterol, Double maxCholesterol, Double minFluoride, Double maxFluoride, Double minAlcohol, Double maxAlcohol, Double minCaffeine, Double maxCaffeine, Double minSaturatedFat, Double maxSaturatedFat, Double minVitaminA, Double maxVitaminA, Double minVitaminC, Double maxVitaminC, Double minVitaminD, Double maxVitaminD, Double minVitaminE, Double maxVitaminE, Double minVitaminK, Double maxVitaminK, Double minVitaminB1, Double maxVitaminB1, Double minVitaminB2, Double maxVitaminB2, Double minVitaminB3, Double maxVitaminB3, Double minVitaminB5, Double maxVitaminB5, Double minVitaminB6, Double maxVitaminB6, Double minVitaminB12, Double maxVitaminB12, String sort, String sortDirection, Integer offset, Integer number) throws ApiException {
        okhttp3.Call localVarCall = searchRecipesAPIValidateBeforeCall(query, cuisines, excludeCuisines, mealType, diet, intolerances, equipment, includeIngredients, excludeIngredients, fillIngredients, addRecipeInformation, maxTime, minServings, maxServings, minCalories, maxCalories, minCarbs, maxCarbs, minProtein, maxProtein, minFat, maxFat, minSugar, maxSugar, minFiber, maxFiber, minFolate, maxFolate, minFolicAcid, maxFolicAcid, minIodine, maxIodine, minIron, maxIron, minZinc, maxZinc, minMagnesium, maxMagnesium, minManganese, maxManganese, minPhosphorus, maxPhosphorus, minPotassium, maxPotassium, minSodium, maxSodium, minSelenium, maxSelenium, minCopper, maxCopper, minCalcium, maxCalcium, minCholine, maxCholine, minCholesterol, maxCholesterol, minFluoride, maxFluoride, minAlcohol, maxAlcohol, minCaffeine, maxCaffeine, minSaturatedFat, maxSaturatedFat, minVitaminA, maxVitaminA, minVitaminC, maxVitaminC, minVitaminD, maxVitaminD, minVitaminE, maxVitaminE, minVitaminK, maxVitaminK, minVitaminB1, maxVitaminB1, minVitaminB2, maxVitaminB2, minVitaminB3, maxVitaminB3, minVitaminB5, maxVitaminB5, minVitaminB6, maxVitaminB6, minVitaminB12, maxVitaminB12, sort, sortDirection, offset, number, null);
        Type localVarReturnType = new TypeToken<SearchRecipesAPI200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Search Recipes API (asynchronously)
     * Search and filter thousands of recipes with natural language, e.g. pasta recipes without mushrooms but with truffles. You can filter by ingredients, diet, cuisine, meal type, macro and micro nutrition, intolerances, and much more.
     * @param query The search query. (optional)
     * @param cuisines The cuisine(s) of the recipes. One or more, comma-separated (will be interpreted as &#39;OR&#39;). (optional)
     * @param excludeCuisines The cuisine(s) the recipes must not match. One or more, comma-separated (will be interpreted as &#39;AND&#39;). (optional)
     * @param mealType The type of the recipe, one of: main course,side dish,dessert,appetizer,salad,bread,breakfast,soup,beverage,sauce,drink. (optional)
     * @param diet The diet the recipes must adhere to. One of the following: paleo,primal,grain-free,pescetarian,lacto vegetarian,ovo vegetarian,vegan,vegetarian. (optional)
     * @param intolerances A comma-separated list of intolerances. All recipes returned must not contain ingredients that are not suitable for people with the intolerances entered. (optional)
     * @param equipment The equipment required. Multiple values will be interpreted as &#39;OR&#39;. (optional)
     * @param includeIngredients A comma-separated list of ingredients that should/must be used in the recipes. (optional)
     * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the recipes must not contain. (optional)
     * @param fillIngredients Add information about the ingredients and whether they are used or missing in relation to the query. (optional)
     * @param addRecipeInformation If set to true, you get more information about the recipes returned. (optional)
     * @param maxTime The maximum time in minutes it should take to prepare and cook the recipe. (optional)
     * @param minServings The minimum amount of servings the recipe is for. (optional)
     * @param maxServings The maximum amount of servings the recipe is for. (optional)
     * @param minCalories The minimum amount of calories the recipe must have per serving. (optional)
     * @param maxCalories The maximum amount of calories the recipe can have per serving. (optional)
     * @param minCarbs The minimum amount of carbohydrates in grams the recipe must have per serving. (optional)
     * @param maxCarbs The maximum amount of carbohydrates in grams the recipe can have per serving. (optional)
     * @param minProtein The minimum amount of protein in grams the recipe must have per serving. (optional)
     * @param maxProtein The maximum amount of protein in grams the recipe can have per serving. (optional)
     * @param minFat The minimum amount of fat in grams the recipe must have per serving. (optional)
     * @param maxFat The maximum amount of fat in grams the recipe can have per serving. (optional)
     * @param minSugar The minimum amount of sugar in grams the recipe must have per serving. (optional)
     * @param maxSugar The maximum amount of sugar in grams the recipe can have per serving. (optional)
     * @param minFiber The minimum amount of fiber in grams the recipe must have per serving. (optional)
     * @param maxFiber The maximum amount of fiber in grams the recipe can have per serving. (optional)
     * @param minFolate The minimum amount of folate in micrograms the recipe must have per serving. (optional)
     * @param maxFolate The maximum amount of folate in micrograms the recipe can have per serving. (optional)
     * @param minFolicAcid The minimum amount of folic acid in micrograms the recipe must have per serving. (optional)
     * @param maxFolicAcid The maximum amount of folic acid in micrograms the recipe can have per serving. (optional)
     * @param minIodine The minimum amount of iodine in micrograms the recipe must have per serving. (optional)
     * @param maxIodine The maximum amount of iodine in micrograms the recipe can have per serving. (optional)
     * @param minIron The minimum amount of iron in milligrams the recipe must have per serving. (optional)
     * @param maxIron The maximum amount of iron in milligrams the recipe can have per serving. (optional)
     * @param minZinc The minimum amount of zinc in milligrams the recipe must have per serving. (optional)
     * @param maxZinc The maximum amount of zinc in milligrams the recipe can have per serving. (optional)
     * @param minMagnesium The minimum amount of magnesium in milligrams the recipe must have per serving. (optional)
     * @param maxMagnesium The maximum amount of magnesium in milligrams the recipe can have per serving. (optional)
     * @param minManganese The minimum amount of manganese in milligrams the recipe must have per serving. (optional)
     * @param maxManganese The maximum amount of manganese in milligrams the recipe can have per serving. (optional)
     * @param minPhosphorus The minimum amount of phosphorus in milligrams the recipe must have per serving. (optional)
     * @param maxPhosphorus The maximum amount of phosphorus in milligrams the recipe can have per serving. (optional)
     * @param minPotassium The minimum amount of potassium in milligrams the recipe must have per serving. (optional)
     * @param maxPotassium The maximum amount of potassium in milligrams the recipe can have per serving. (optional)
     * @param minSodium The minimum amount of sodium in milligrams the recipe must have per serving. (optional)
     * @param maxSodium The maximum amount of sodium in milligrams the recipe can have per serving. (optional)
     * @param minSelenium The minimum amount of selenium in micrograms the recipe must have per serving. (optional)
     * @param maxSelenium The maximum amount of selenium in micrograms the recipe can have per serving. (optional)
     * @param minCopper The minimum amount of copper in milligrams the recipe must have per serving. (optional)
     * @param maxCopper The maximum amount of copper in milligrams the recipe can have per serving. (optional)
     * @param minCalcium The minimum amount of calcium in milligrams the recipe must have per serving. (optional)
     * @param maxCalcium The maximum amount of calcium in milligrams the recipe can have per serving. (optional)
     * @param minCholine The minimum amount of choline in milligrams the recipe must have per serving. (optional)
     * @param maxCholine The maximum amount of choline in milligrams the recipe can have per serving. (optional)
     * @param minCholesterol The minimum amount of cholesterol in milligrams the recipe must have per serving. (optional)
     * @param maxCholesterol The maximum amount of cholesterol in milligrams the recipe can have per serving. (optional)
     * @param minFluoride The minimum amount of fluoride in milligrams the recipe must have per serving. (optional)
     * @param maxFluoride The maximum amount of fluoride in milligrams the recipe can have per serving. (optional)
     * @param minAlcohol The minimum amount of alcohol in grams the recipe must have per serving. (optional)
     * @param maxAlcohol The maximum amount of alcohol in grams the recipe can have per serving. (optional)
     * @param minCaffeine The minimum amount of caffeine in milligrams the recipe must have per serving. (optional)
     * @param maxCaffeine The maximum amount of caffeine in milligrams the recipe can have per serving. (optional)
     * @param minSaturatedFat The minimum amount of saturated fat in grams the recipe must have per serving. (optional)
     * @param maxSaturatedFat The maximum amount of saturated fat in grams the recipe can have per serving. (optional)
     * @param minVitaminA The minimum amount of Vitamin A in IU the recipe must have per serving. (optional)
     * @param maxVitaminA The maximum amount of Vitamin A in IU the recipe can have per serving. (optional)
     * @param minVitaminC The minimum amount of Vitamin C in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminC The maximum amount of Vitamin C in milligrams the recipe can have per serving. (optional)
     * @param minVitaminD The minimum amount of Vitamin D in micrograms the recipe must have per serving. (optional)
     * @param maxVitaminD The maximum amount of Vitamin D in micrograms the recipe can have per serving. (optional)
     * @param minVitaminE The minimum amount of Vitamin E in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminE The maximum amount of Vitamin E in milligrams the recipe can have per serving. (optional)
     * @param minVitaminK The minimum amount of Vitamin K in micrograms the recipe must have per serving. (optional)
     * @param maxVitaminK The maximum amount of Vitamin K in micrograms the recipe can have per serving. (optional)
     * @param minVitaminB1 The minimum amount of Vitamin B1 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB1 The maximum amount of Vitamin B1 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB2 The minimum amount of Vitamin B2 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB2 The maximum amount of Vitamin B2 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB3 The minimum amount of Vitamin B3 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB3 The maximum amount of Vitamin B3 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB5 The minimum amount of Vitamin B5 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB5 The maximum amount of Vitamin B5 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB6 The minimum amount of Vitamin B6 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB6 The maximum amount of Vitamin B6 in milligrams the recipe can have per serving. (optional)
     * @param minVitaminB12 The minimum amount of Vitamin B12 in milligrams the recipe must have per serving. (optional)
     * @param maxVitaminB12 The maximum amount of Vitamin B12 in milligrams the recipe can have per serving. (optional)
     * @param sort The strategy to sort recipes by. (optional)
     * @param sortDirection Whether to sort ascending or descending (ASC or DESC). (optional)
     * @param offset The number of recipes to skip, between 0 and 900. (optional)
     * @param number The number of recipes, between 1 and 100. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-recipes-api/">Search Recipes API Documentation</a>
     */
    public okhttp3.Call searchRecipesAPIAsync(String query, String cuisines, String excludeCuisines, String mealType, String diet, String intolerances, String equipment, String includeIngredients, String excludeIngredients, Boolean fillIngredients, Boolean addRecipeInformation, Integer maxTime, Integer minServings, Integer maxServings, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minSugar, Double maxSugar, Double minFiber, Double maxFiber, Double minFolate, Double maxFolate, Double minFolicAcid, Double maxFolicAcid, Double minIodine, Double maxIodine, Double minIron, Double maxIron, Double minZinc, Double maxZinc, Double minMagnesium, Double maxMagnesium, Double minManganese, Double maxManganese, Double minPhosphorus, Double maxPhosphorus, Double minPotassium, Double maxPotassium, Double minSodium, Double maxSodium, Double minSelenium, Double maxSelenium, Double minCopper, Double maxCopper, Double minCalcium, Double maxCalcium, Double minCholine, Double maxCholine, Double minCholesterol, Double maxCholesterol, Double minFluoride, Double maxFluoride, Double minAlcohol, Double maxAlcohol, Double minCaffeine, Double maxCaffeine, Double minSaturatedFat, Double maxSaturatedFat, Double minVitaminA, Double maxVitaminA, Double minVitaminC, Double maxVitaminC, Double minVitaminD, Double maxVitaminD, Double minVitaminE, Double maxVitaminE, Double minVitaminK, Double maxVitaminK, Double minVitaminB1, Double maxVitaminB1, Double minVitaminB2, Double maxVitaminB2, Double minVitaminB3, Double maxVitaminB3, Double minVitaminB5, Double maxVitaminB5, Double minVitaminB6, Double maxVitaminB6, Double minVitaminB12, Double maxVitaminB12, String sort, String sortDirection, Integer offset, Integer number, final ApiCallback<SearchRecipesAPI200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = searchRecipesAPIValidateBeforeCall(query, cuisines, excludeCuisines, mealType, diet, intolerances, equipment, includeIngredients, excludeIngredients, fillIngredients, addRecipeInformation, maxTime, minServings, maxServings, minCalories, maxCalories, minCarbs, maxCarbs, minProtein, maxProtein, minFat, maxFat, minSugar, maxSugar, minFiber, maxFiber, minFolate, maxFolate, minFolicAcid, maxFolicAcid, minIodine, maxIodine, minIron, maxIron, minZinc, maxZinc, minMagnesium, maxMagnesium, minManganese, maxManganese, minPhosphorus, maxPhosphorus, minPotassium, maxPotassium, minSodium, maxSodium, minSelenium, maxSelenium, minCopper, maxCopper, minCalcium, maxCalcium, minCholine, maxCholine, minCholesterol, maxCholesterol, minFluoride, maxFluoride, minAlcohol, maxAlcohol, minCaffeine, maxCaffeine, minSaturatedFat, maxSaturatedFat, minVitaminA, maxVitaminA, minVitaminC, maxVitaminC, minVitaminD, maxVitaminD, minVitaminE, maxVitaminE, minVitaminK, maxVitaminK, minVitaminB1, maxVitaminB1, minVitaminB2, maxVitaminB2, minVitaminB3, maxVitaminB3, minVitaminB5, maxVitaminB5, minVitaminB6, maxVitaminB6, minVitaminB12, maxVitaminB12, sort, sortDirection, offset, number, _callback);
        Type localVarReturnType = new TypeToken<SearchRecipesAPI200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for searchRestaurantsAPI
     * @param lat The latitude to search around. (required)
     * @param lon The longitude to search around. (required)
     * @param query The search query. (optional)
     * @param distance The maximum distance of the restaurant in miles around the given location. (optional)
     * @param budget The budget in USD for the meal. (optional)
     * @param minRating The minimum rating of the restaurants in range [0,5]. (optional)
     * @param cuisine The cuisine that the restaurants should support. (optional)
     * @param isOpen Whether the restaurants have to be open now. (optional)
     * @param page The page of the results. (optional)
     * @param sort The sort parameter, one of: cheapest, fastest, rating, distance or relevance. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-restaurants-api/">Search Restaurants API Documentation</a>
     */
    public okhttp3.Call searchRestaurantsAPICall(Double lat, Double lon, String query, Integer distance, Double budget, Double minRating, String cuisine, Boolean isOpen, Integer page, String sort, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/search-restaurants";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (query != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("query", query));
        }

        if (lat != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("lat", lat));
        }

        if (lon != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("lon", lon));
        }

        if (distance != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("distance", distance));
        }

        if (budget != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("budget", budget));
        }

        if (minRating != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("min-rating", minRating));
        }

        if (cuisine != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("cuisine", cuisine));
        }

        if (isOpen != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("is-open", isOpen));
        }

        if (page != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("page", page));
        }

        if (sort != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("sort", sort));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "apiKey", "headerApiKey" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call searchRestaurantsAPIValidateBeforeCall(Double lat, Double lon, String query, Integer distance, Double budget, Double minRating, String cuisine, Boolean isOpen, Integer page, String sort, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'lat' is set
        if (lat == null) {
            throw new ApiException("Missing the required parameter 'lat' when calling searchRestaurantsAPI(Async)");
        }

        // verify the required parameter 'lon' is set
        if (lon == null) {
            throw new ApiException("Missing the required parameter 'lon' when calling searchRestaurantsAPI(Async)");
        }

        return searchRestaurantsAPICall(lat, lon, query, distance, budget, minRating, cuisine, isOpen, page, sort, _callback);

    }

    /**
     * Search Restaurants API
     * Search through thousands of restaurants (in North America) by location, cuisine, budget, and more.
     * @param lat The latitude to search around. (required)
     * @param lon The longitude to search around. (required)
     * @param query The search query. (optional)
     * @param distance The maximum distance of the restaurant in miles around the given location. (optional)
     * @param budget The budget in USD for the meal. (optional)
     * @param minRating The minimum rating of the restaurants in range [0,5]. (optional)
     * @param cuisine The cuisine that the restaurants should support. (optional)
     * @param isOpen Whether the restaurants have to be open now. (optional)
     * @param page The page of the results. (optional)
     * @param sort The sort parameter, one of: cheapest, fastest, rating, distance or relevance. (optional)
     * @return SearchRestaurantsAPI200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-restaurants-api/">Search Restaurants API Documentation</a>
     */
    public SearchRestaurantsAPI200Response searchRestaurantsAPI(Double lat, Double lon, String query, Integer distance, Double budget, Double minRating, String cuisine, Boolean isOpen, Integer page, String sort) throws ApiException {
        ApiResponse<SearchRestaurantsAPI200Response> localVarResp = searchRestaurantsAPIWithHttpInfo(lat, lon, query, distance, budget, minRating, cuisine, isOpen, page, sort);
        return localVarResp.getData();
    }

    /**
     * Search Restaurants API
     * Search through thousands of restaurants (in North America) by location, cuisine, budget, and more.
     * @param lat The latitude to search around. (required)
     * @param lon The longitude to search around. (required)
     * @param query The search query. (optional)
     * @param distance The maximum distance of the restaurant in miles around the given location. (optional)
     * @param budget The budget in USD for the meal. (optional)
     * @param minRating The minimum rating of the restaurants in range [0,5]. (optional)
     * @param cuisine The cuisine that the restaurants should support. (optional)
     * @param isOpen Whether the restaurants have to be open now. (optional)
     * @param page The page of the results. (optional)
     * @param sort The sort parameter, one of: cheapest, fastest, rating, distance or relevance. (optional)
     * @return ApiResponse&lt;SearchRestaurantsAPI200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-restaurants-api/">Search Restaurants API Documentation</a>
     */
    public ApiResponse<SearchRestaurantsAPI200Response> searchRestaurantsAPIWithHttpInfo(Double lat, Double lon, String query, Integer distance, Double budget, Double minRating, String cuisine, Boolean isOpen, Integer page, String sort) throws ApiException {
        okhttp3.Call localVarCall = searchRestaurantsAPIValidateBeforeCall(lat, lon, query, distance, budget, minRating, cuisine, isOpen, page, sort, null);
        Type localVarReturnType = new TypeToken<SearchRestaurantsAPI200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Search Restaurants API (asynchronously)
     * Search through thousands of restaurants (in North America) by location, cuisine, budget, and more.
     * @param lat The latitude to search around. (required)
     * @param lon The longitude to search around. (required)
     * @param query The search query. (optional)
     * @param distance The maximum distance of the restaurant in miles around the given location. (optional)
     * @param budget The budget in USD for the meal. (optional)
     * @param minRating The minimum rating of the restaurants in range [0,5]. (optional)
     * @param cuisine The cuisine that the restaurants should support. (optional)
     * @param isOpen Whether the restaurants have to be open now. (optional)
     * @param page The page of the results. (optional)
     * @param sort The sort parameter, one of: cheapest, fastest, rating, distance or relevance. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Success </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized </td><td>  -  </td></tr>
        <tr><td> 402 </td><td> Payment Required </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> Not Found </td><td>  -  </td></tr>
        <tr><td> 406 </td><td> Not Acceptable </td><td>  -  </td></tr>
        <tr><td> 429 </td><td> Too Many Requests </td><td>  -  </td></tr>
     </table>
     * Read entire docs
     * @see <a href="https://apileague.com/apis/search-restaurants-api/">Search Restaurants API Documentation</a>
     */
    public okhttp3.Call searchRestaurantsAPIAsync(Double lat, Double lon, String query, Integer distance, Double budget, Double minRating, String cuisine, Boolean isOpen, Integer page, String sort, final ApiCallback<SearchRestaurantsAPI200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = searchRestaurantsAPIValidateBeforeCall(lat, lon, query, distance, budget, minRating, cuisine, isOpen, page, sort, _callback);
        Type localVarReturnType = new TypeToken<SearchRestaurantsAPI200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
